/*
 * Copyright 2021-2021 Alfresco Software, Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.29).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package org.alfresco.activiti.runtime.handler;

import org.alfresco.activiti.runtime.model.CandidateGroupsPayload;
import org.alfresco.activiti.runtime.model.EntryResponseContentActivitiErrorMessage;
import org.alfresco.activiti.runtime.model.ListResponseContentCandidateGroup;

import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.bind.annotation.CookieValue;
import org.springframework.cloud.openfeign.CollectionFormat;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;

@Api(value = "CandidateGroupControllerImpl", description = "the CandidateGroupControllerImpl API")
public interface CandidateGroupControllerImplApi {

    @ApiOperation(value = "addCandidateGroups", nickname = "addCandidateGroups", notes = "", tags={ "candidate-group-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK"),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}/candidate-groups",
        produces = "*/*,*/*,*/*,*/*,*/*,*/*", 
        consumes = "application/json",
        method = RequestMethod.POST)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> addCandidateGroups(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "", required=true ) @Valid @RequestBody CandidateGroupsPayload body);


    @ApiOperation(value = "deleteCandidateGroups", nickname = "deleteCandidateGroups", notes = "", tags={ "candidate-group-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK"),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}/candidate-groups",
        produces = "*/*,*/*,*/*,*/*,*/*,*/*", 
        consumes = "application/json",
        method = RequestMethod.DELETE)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> deleteCandidateGroups(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "", required=true ) @Valid @RequestBody CandidateGroupsPayload body);


    @ApiOperation(value = "getGroupCandidates", nickname = "getGroupCandidates", notes = "", response = ListResponseContentCandidateGroup.class, tags={ "candidate-group-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = ListResponseContentCandidateGroup.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}/candidate-groups",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<ListResponseContentCandidateGroup> getGroupCandidates(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId);

}
