/*
 * Copyright 2021-2021 Alfresco Software, Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.29).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package org.alfresco.activiti.runtime.handler;

import org.alfresco.activiti.runtime.model.EntryResponseContentActivitiErrorMessage;
import org.alfresco.activiti.runtime.model.EntryResponseContentCloudProcessDefinition;
import org.alfresco.activiti.runtime.model.ListResponseContentExtendedCloudProcessDefinition;
import java.util.Map;

import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.bind.annotation.CookieValue;
import org.springframework.cloud.openfeign.CollectionFormat;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;

@Api(value = "ProcessDefinitionControllerImpl", description = "the ProcessDefinitionControllerImpl API")
public interface ProcessDefinitionControllerImplApi {

    @ApiOperation(value = "getProcessDefinition", nickname = "getProcessDefinition", notes = "", response = EntryResponseContentCloudProcessDefinition.class, tags={ "process-definition-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = EntryResponseContentCloudProcessDefinition.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/process-definitions/{id}",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<EntryResponseContentCloudProcessDefinition> getProcessDefinition(@ApiParam(value = "", required=true) @PathVariable("id") String id);


    @ApiOperation(value = "getProcessDefinitions", nickname = "getProcessDefinitions", notes = "", response = ListResponseContentExtendedCloudProcessDefinition.class, tags={ "process-definition-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = ListResponseContentExtendedCloudProcessDefinition.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/process-definitions",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<ListResponseContentExtendedCloudProcessDefinition> getProcessDefinitions(@ApiParam(value = "List of values to include in response", defaultValue = "[]") @Valid @RequestParam(value = "include", required = false, defaultValue="[]") List<String> include, @ApiParam(value = "") @Valid @RequestParam(value = "maxItems", required = false) Integer maxItems, @ApiParam(value = "") @Valid @RequestParam(value = "skipCount", required = false) Integer skipCount, @ApiParam(value = "") @Valid @RequestParam(value = "sort", required = false) String sort);


    @ApiOperation(value = "getProcessDiagram", nickname = "getProcessDiagram", notes = "", response = String.class, tags={ "process-definition-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = String.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/process-definitions/{id}/model",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<String> getProcessDiagram(@ApiParam(value = "", required=true) @PathVariable("id") String id);


    @ApiOperation(value = "getProcessModelStaticValuesMappingForStartEvent", nickname = "getProcessModelStaticValuesMappingForStartEvent", notes = "", response = Object.class, responseContainer = "Map", tags={ "process-definition-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = Map.class, responseContainer = "Map"),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/process-definitions/{id}/static-values",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Map<String, Object>> getProcessModelStaticValuesMappingForStartEvent(@ApiParam(value = "", required=true) @PathVariable("id") String id);

}
