/*
 * Copyright 2021-2021 Alfresco Software, Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.29).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package org.alfresco.activiti.runtime.handler;

import org.alfresco.activiti.runtime.model.AssignTaskPayload;
import org.alfresco.activiti.runtime.model.CompleteTaskPayload;
import org.alfresco.activiti.runtime.model.CreateTaskPayload;
import org.alfresco.activiti.runtime.model.EntryResponseContentActivitiErrorMessage;
import org.alfresco.activiti.runtime.model.EntryResponseContentCloudTask;
import org.alfresco.activiti.runtime.model.ListResponseContentCloudTask;
import org.alfresco.activiti.runtime.model.SaveTaskPayload;
import org.alfresco.activiti.runtime.model.UpdateTaskPayload;

import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.bind.annotation.CookieValue;
import org.springframework.cloud.openfeign.CollectionFormat;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;

@Api(value = "TaskControllerImpl", description = "the TaskControllerImpl API")
public interface TaskControllerImplApi {

    @ApiOperation(value = "assign", nickname = "assign", notes = "", response = EntryResponseContentCloudTask.class, tags={ "task-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = EntryResponseContentCloudTask.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}/assign",
        produces = "application/json", 
        consumes = "application/json",
        method = RequestMethod.POST)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<EntryResponseContentCloudTask> assign(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "", required=true ) @Valid @RequestBody AssignTaskPayload body);


    @ApiOperation(value = "claimTask", nickname = "claimTask", notes = "", response = EntryResponseContentCloudTask.class, tags={ "task-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = EntryResponseContentCloudTask.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}/claim",
        produces = "application/json", 
        method = RequestMethod.POST)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<EntryResponseContentCloudTask> claimTask(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId);


    @ApiOperation(value = "completeTask", nickname = "completeTask", notes = "", response = EntryResponseContentCloudTask.class, tags={ "task-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = EntryResponseContentCloudTask.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}/complete",
        produces = "application/json", 
        consumes = "application/json",
        method = RequestMethod.POST)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<EntryResponseContentCloudTask> completeTask(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "" ) @Valid @RequestBody CompleteTaskPayload body);


    @ApiOperation(value = "createNewTask", nickname = "createNewTask", notes = "", response = EntryResponseContentCloudTask.class, tags={ "task-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = EntryResponseContentCloudTask.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks",
        produces = "application/json", 
        consumes = "application/json",
        method = RequestMethod.POST)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<EntryResponseContentCloudTask> createNewTask(@ApiParam(value = "", required=true ) @Valid @RequestBody CreateTaskPayload body);


    @ApiOperation(value = "deleteTask", nickname = "deleteTask", notes = "", response = EntryResponseContentCloudTask.class, tags={ "task-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = EntryResponseContentCloudTask.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}",
        produces = "application/json", 
        method = RequestMethod.DELETE)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<EntryResponseContentCloudTask> deleteTask(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId);


    @ApiOperation(value = "getSubtasks", nickname = "getSubtasks", notes = "", response = ListResponseContentCloudTask.class, tags={ "task-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = ListResponseContentCloudTask.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}/subtasks",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<ListResponseContentCloudTask> getSubtasks(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "") @Valid @RequestParam(value = "maxItems", required = false) Integer maxItems, @ApiParam(value = "") @Valid @RequestParam(value = "skipCount", required = false) Integer skipCount, @ApiParam(value = "") @Valid @RequestParam(value = "sort", required = false) String sort);


    @ApiOperation(value = "getTaskById", nickname = "getTaskById", notes = "", response = EntryResponseContentCloudTask.class, tags={ "task-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = EntryResponseContentCloudTask.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<EntryResponseContentCloudTask> getTaskById(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId);


    @ApiOperation(value = "getTasks", nickname = "getTasks", notes = "", response = ListResponseContentCloudTask.class, tags={ "task-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = ListResponseContentCloudTask.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<ListResponseContentCloudTask> getTasks(@ApiParam(value = "") @Valid @RequestParam(value = "maxItems", required = false) Integer maxItems, @ApiParam(value = "") @Valid @RequestParam(value = "skipCount", required = false) Integer skipCount, @ApiParam(value = "") @Valid @RequestParam(value = "sort", required = false) String sort);


    @ApiOperation(value = "releaseTask", nickname = "releaseTask", notes = "", response = EntryResponseContentCloudTask.class, tags={ "task-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = EntryResponseContentCloudTask.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}/release",
        produces = "application/json", 
        method = RequestMethod.POST)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<EntryResponseContentCloudTask> releaseTask(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId);


    @ApiOperation(value = "saveTask", nickname = "saveTask", notes = "", tags={ "task-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK"),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}/save",
        produces = "*/*,*/*,*/*,*/*,*/*,*/*", 
        consumes = "application/json",
        method = RequestMethod.POST)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> saveTask(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "", required=true ) @Valid @RequestBody SaveTaskPayload body);


    @ApiOperation(value = "updateTask", nickname = "updateTask", notes = "", response = EntryResponseContentCloudTask.class, tags={ "task-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = EntryResponseContentCloudTask.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}",
        produces = "application/json", 
        consumes = "application/json",
        method = RequestMethod.PUT)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<EntryResponseContentCloudTask> updateTask(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "", required=true ) @Valid @RequestBody UpdateTaskPayload body);

}
