/*
 * Copyright 2021-2021 Alfresco Software, Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.29).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package org.alfresco.activiti.runtime.handler;

import org.alfresco.activiti.runtime.model.CreateTaskVariablePayload;
import org.alfresco.activiti.runtime.model.EntryResponseContentActivitiErrorMessage;
import org.alfresco.activiti.runtime.model.ListResponseContentCloudVariableInstance;
import org.alfresco.activiti.runtime.model.UpdateTaskVariablePayload;

import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.bind.annotation.CookieValue;
import org.springframework.cloud.openfeign.CollectionFormat;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;

@Api(value = "TaskVariableControllerImpl", description = "the TaskVariableControllerImpl API")
public interface TaskVariableControllerImplApi {

    @ApiOperation(value = "createVariable", nickname = "createVariable", notes = "", tags={ "task-variable-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK"),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}/variables",
        produces = "*/*,*/*,*/*,*/*,*/*,*/*", 
        consumes = "application/json",
        method = RequestMethod.POST)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> createVariable(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "", required=true ) @Valid @RequestBody CreateTaskVariablePayload body);


    @ApiOperation(value = "getVariables", nickname = "getVariables", notes = "", response = ListResponseContentCloudVariableInstance.class, tags={ "task-variable-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK", response = ListResponseContentCloudVariableInstance.class),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}/variables",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<ListResponseContentCloudVariableInstance> getVariables(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId);


    @ApiOperation(value = "updateVariable", nickname = "updateVariable", notes = "", tags={ "task-variable-controller-impl", })
    @ApiResponses(value = { 
        @ApiResponse(code = 400, message = "Bad Request", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 404, message = "Not Found", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 422, message = "Unprocessable Entity", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 403, message = "Forbidden", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 204, message = "No Content", response = EntryResponseContentActivitiErrorMessage.class),
        @ApiResponse(code = 200, message = "OK"),
        @ApiResponse(code = 401, message = "Unauthorized") })
    @RequestMapping(value = "/v1/tasks/{taskId}/variables/{variableName}",
        produces = "*/*,*/*,*/*,*/*,*/*,*/*", 
        consumes = "application/json",
        method = RequestMethod.PUT)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> updateVariable(@ApiParam(value = "", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "", required=true) @PathVariable("variableName") String variableName, @ApiParam(value = "", required=true ) @Valid @RequestBody UpdateTaskVariablePayload body);

}
