/*
 * Copyright 2021-2021 Alfresco Software, Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.alfresco.activiti.runtime.model;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.alfresco.activiti.runtime.model.AnnotatedMember;
import org.springframework.validation.annotation.Validated;
import javax.validation.Valid;
import javax.validation.constraints.*;

/**
 * MergeInfo
 */
@Validated


public class MergeInfo   {
  @JsonProperty("getter")
  private AnnotatedMember getter = null;

  @JsonProperty("fromDefaults")
  private Boolean fromDefaults = null;

  public MergeInfo getter(AnnotatedMember getter) {
    this.getter = getter;
    return this;
  }

  /**
   * Get getter
   * @return getter
   **/
  @ApiModelProperty(value = "")
  
    @Valid
    public AnnotatedMember getGetter() {
    return getter;
  }

  public void setGetter(AnnotatedMember getter) {
    this.getter = getter;
  }

  public MergeInfo fromDefaults(Boolean fromDefaults) {
    this.fromDefaults = fromDefaults;
    return this;
  }

  /**
   * Get fromDefaults
   * @return fromDefaults
   **/
  @ApiModelProperty(value = "")
  
    public Boolean isFromDefaults() {
    return fromDefaults;
  }

  public void setFromDefaults(Boolean fromDefaults) {
    this.fromDefaults = fromDefaults;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MergeInfo mergeInfo = (MergeInfo) o;
    return Objects.equals(this.getter, mergeInfo.getter) &&
        Objects.equals(this.fromDefaults, mergeInfo.fromDefaults);
  }

  @Override
  public int hashCode() {
    return Objects.hash(getter, fromDefaults);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MergeInfo {\n");
    
    sb.append("    getter: ").append(toIndentedString(getter)).append("\n");
    sb.append("    fromDefaults: ").append(toIndentedString(fromDefaults)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
